#include <stdio.h>
#include <stdlib.h>

void change_by_val(int x) {
    x = 2 * x;
}

void change_by_ref(int* ptr) {
    *ptr = 2 * (*ptr);
}

int cube_by_val(int x) {
    return x*x*x;
}

void cube_by_ref(int* ptr) {
    *ptr = (*ptr) * (*ptr) * (*ptr);
}

void swap(int* x, int* y) {
    int tmp = *x;
    *x = *y;
    *y = tmp;
}

void selection_sort(int a[], int n) {
    int i, j, min_idx;
    for (i = 0; i < n-1; i++) {
        min_idx = i;
        for (j = i+1; j < n; j++) {
            if (a[min_idx] > a[j]) {
                min_idx = j;
            }
        }
        swap(&a[i], &a[min_idx]);
    }
}

void print_arr(int a[], int n) {
    int i;
    for (i = 0; i < n; i++) {
        printf("%d ", a[i]); /// moze i  *(a+i)
    }
    printf("\n");
}

int main()
{
    int x = 10;
    int* x_ptr = &x;

    printf("%d\n", x);

    *x_ptr = 15;

    printf("%d\n", x);

    printf("%d\n", *x_ptr);

    printf("%p\n", x_ptr);

    printf("%d %d\n", x, *(&x));
    printf("%p %p %p\n", x_ptr, &(*x_ptr), &x_ptr);

    change_by_val(x);
    printf("%d\n", x);

    change_by_ref(x_ptr);
    printf("%d\n", x);

    //x = cube_by_val(x);
    cube_by_ref(&x);
    printf("%d\n", x);

    printf("%d\n", sizeof(x));
    printf("%d\n", sizeof(x_ptr));

    int arr[10];
    printf("%d\n", sizeof(arr));

    int a[] = { 2, 6, 4, 8, 10, 12, 89, 68, 45, 37 };
    int n = 10;

    printf("%d\n", *a);
    printf("%d\n", *(a + 3));

    print_arr(a, n);
    selection_sort(a, n);
    print_arr(a, n);

    int m = 5;
    int* b = malloc(m*sizeof(int));
    b[0] = 1;
    printf("%d\n", b[0]);
    printf("%d\n", sizeof(b));

    free(b);

    return 0;
}
